import type { NodePath } from '@babel/traverse';
import type * as t from '@babel/types';
import type { Metadata } from '../types';
/**
 * Get comments for `path` in both the line before and on the current line.
 *
 * e.g.
 * `<div css={{color: 'green'}} /> // @compiled-disable-line` will output `{before: [], current: [...]}
 *
 * @param path {NodePath<t.Node>}
 * @param meta {Metadata} Context for the transform
 * @returns {before: t.CommentLine[], current: t.CommentLine[]} Comments before and on the current line as the input path
 */
export declare const getNodeComments: (path: NodePath<t.Node>, meta: Metadata) => {
    before: t.CommentLine[];
    current: t.CommentLine[];
};
